from .models import sorts


class sortAll:
    sortList = []
    level = 0

    # 查询所有子类信息
    @classmethod
    def getChildren(cls, pid=0, space="", rs=[]):
        if not rs:
            rs = sorts.objects.filter(parentid=pid).order_by("orders")
            del cls.sortList[:]
            cls.level = 0
            # 每次调用之前，清空列表
        if rs:
            for dic in rs:
                if not cls.level:
                    cls.level = dic.level
                # 将开始的父级水平定义为第一级
                lev = dic.level  #表中级别
                if (lev == cls.level): #第一级
                    dic.space = ""
                elif (lev == cls.level + 1):
                    space = "　　|---->"
                    dic.space = space
                else:
                    dic.space = space
                cls.sortList.append(dic)
                pid = dic.id
                rs = sorts.objects.filter(parentid=pid).order_by("orders")
                if rs:
                    cls.getChildren(pid, "　　|" + space, rs)

        return cls.sortList

    @classmethod
    # selectName : select 的name属性值
    # pid        : 父级id
    # currentid  : 当前默认选中类别
    # top        : 是否显示顶级类别
    def selectTree(cls, pid=0, selectName="parentid", currentid=0, top=False):
        lists = cls.getChildren(pid)
        strs = '<select name="' + selectName + '">';
        if top:
            strs += '<option value="0">一级分类</option>'

        for row in lists:
            if (row.id == currentid):
                strs += '<option value="' + str(row.id) + '" selected>' + row.space + row.title + '</option>'
            else:
                strs += '<option value="' + str(row.id) + '">' + row.space + row.title + '</option>'
        strs += '</select>'

        return strs

    @classmethod
    def getParentName(cls, sortpath="", fuhao="->"):
        str = ""
        if sortpath:
            sortpath = sortpath[2:len(sortpath) - 1]
            list = sortpath.split(",")
            for index in range(len(list)):
                row = sorts.objects.get(id=list[index])
                if index == 0:
                    str += row.title
                else:
                    str += fuhao + row.title
        return str

